#define WIN32_LEAN_AND_MEAN
//#define UNICODE
#ifdef UNICODE
  #define _UNICODE
#endif
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <windows.h>
#include <tchar.h>
#include <stdlib.h>
#define AH_STATIC_LINKING  //Hooks_DLL should bring as few modules as possible
#include <ApiHooks.h>      //link all statically (no MSVCRT)

#include "GlobalC.h"
#define IsNT ((int)GetVersion()>0)

#ifdef TRY_DEBUGGEE
  #define SAFE_DEBUGGEE
#endif


/////////////////////////////////////////////////////////
typedef struct _CMDSHOW {
    WORD MustBe2;
    WORD HowToShow;
} CMDSHOW, *LPCMDSHOW;

typedef struct _PASSTR {
    BYTE Length;
    char String[1];
} PASSTR, *LPPASSTR;

typedef struct _LOADPARMS32 {  
    LPSTR lpEnvAddress;
    LPPASSTR lpCmdLine;
    LPCMDSHOW lpCmdShow;
    DWORD dwReserved;
} LOADPARMS32, *LPLOADPARMS32;

typedef BOOL      (WINAPI *TCreateProcessW)(LPCWSTR, LPWSTR, LPSECURITY_ATTRIBUTES,
                         LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCWSTR,
                         LPSTARTUPINFOW, LPPROCESS_INFORMATION);
typedef BOOL      (WINAPI *TCreateProcessA)(LPCSTR, LPSTR, LPSECURITY_ATTRIBUTES,
                         LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCSTR,
                         LPSTARTUPINFOA, LPPROCESS_INFORMATION);
typedef UINT      (WINAPI *TWinExec)(LPCSTR, UINT);
typedef DWORD     (WINAPI *TLoadModule)(LPCSTR, LPVOID); //LPLOADPARMS32);
typedef HINSTANCE (WINAPI *TLoadLibraryA)(LPCSTR);
typedef HINSTANCE (WINAPI *TLoadLibraryExA)(LPCSTR, HANDLE, DWORD);
typedef FARPROC   (WINAPI *TGetProcAddress)(HMODULE, LPCSTR);

TCreateProcessW OldCreateProcessW = NULL;
TCreateProcessA OldCreateProcessA = NULL;
TWinExec        OldWinExec        = NULL;
TLoadModule     OldLoadModule     = NULL;
TLoadLibraryA   OldLoadLibraryA   = NULL;
TLoadLibraryExA OldLoadLibraryExA = NULL;
TGetProcAddress OldGetProcAddress = NULL;


BOOL      WINAPI NewCreateProcessW(LPCWSTR, LPWSTR, LPSECURITY_ATTRIBUTES,
                         LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCWSTR,
                         LPSTARTUPINFOW, LPPROCESS_INFORMATION);
BOOL      WINAPI NewCreateProcessA(LPCSTR, LPSTR, LPSECURITY_ATTRIBUTES,
                         LPSECURITY_ATTRIBUTES, BOOL, DWORD, LPVOID, LPCSTR,
                         LPSTARTUPINFOA, LPPROCESS_INFORMATION);
UINT      WINAPI NewWinExec(LPCSTR, UINT);
DWORD     WINAPI NewLoadModule(LPCSTR, LPVOID); //LPLOADPARMS32);
HINSTANCE WINAPI NewLoadLibraryA(LPCSTR);
HINSTANCE WINAPI NewLoadLibraryExA(LPCSTR, HANDLE, DWORD);
FARPROC   WINAPI NewGetProcAddress(HMODULE, LPCSTR);

#define NUNHOOKS 256

ADDR_CONTENTS UCPW[NUNHOOKS];
ADDR_CONTENTS UCPA[NUNHOOKS];
ADDR_CONTENTS UWEX[NUNHOOKS];
ADDR_CONTENTS ULOM[NUNHOOKS];
ADDR_CONTENTS ULLA[NUNHOOKS];
ADDR_CONTENTS ULLX[NUNHOOKS];
ADDR_CONTENTS UGPA[NUNHOOKS];

API_UNHOOK UnhookCreateProcessW = {NUNHOOKS, 0, UCPW};
API_UNHOOK UnhookCreateProcessA = {NUNHOOKS, 0, UCPA};
API_UNHOOK UnhookWinExec        = {NUNHOOKS, 0, UWEX};
API_UNHOOK UnhookLoadModule     = {NUNHOOKS, 0, ULOM};
API_UNHOOK UnhookLoadLibraryA   = {NUNHOOKS, 0, ULLA};
API_UNHOOK UnhookLoadLibraryExA = {NUNHOOKS, 0, ULLX};
API_UNHOOK UnhookGetProcAddress = {NUNHOOKS, 0, UGPA};


//Only helper APIs are hooked. Empiry can be applied: specific NT and 9x hook types
//are specified.
//In fact HOOK_ALL_SAFE for all used NT APIs can be replaced by HOOK_OVERWRITE,
//while for used 9x APIs (all > 2GB) by (HOOK_BY_NAME | HOOK_BY_ADDRES + ALL_MODULES).

#define NHOOKS 9
__EXPORT API_HOOK ApiHookChain[NHOOKS] = {
  {NULL,NULL,0},  //empty hook will be changed to dynamic if LoadLibrary(Ex)A will be called in Win9x in order to hook newly loaded module
  {"KERNEL32.DLL", "CreateProcessW", HOOK_ALL_SAFE | HOOK_NOT_9X, &OldCreateProcessW, &UnhookCreateProcessW, NewCreateProcessW},
  {"KERNEL32.DLL", "CreateProcessA", HOOK_ALL_SAFE | HOOK_NOT_NT, &OldCreateProcessA, &UnhookCreateProcessA, NewCreateProcessA},
  {"KERNEL32.DLL", "WinExec",        HOOK_ALL_SAFE | HOOK_NOT_NT, &OldWinExec,        &UnhookWinExec,        NewWinExec},
  {"KERNEL32.DLL", "LoadModule",     HOOK_ALL_SAFE | HOOK_NOT_NT, &OldLoadModule,     &UnhookLoadModule,     NewLoadModule},
  {"KERNEL32.DLL", "LoadLibraryA"  , HOOK_ALL_SAFE | HOOK_NOT_NT, &OldLoadLibraryA,   &UnhookLoadLibraryA,   NewLoadLibraryA},
  {"KERNEL32.DLL", "LoadLibraryExA", HOOK_ALL_SAFE | HOOK_NOT_NT, &OldLoadLibraryExA, &UnhookLoadLibraryExA, NewLoadLibraryExA},
  {"KERNEL32.DLL", "GetProcAddress", HOOK_ALL_SAFE | HOOK_NOT_NT, &OldGetProcAddress, &UnhookGetProcAddress, NewGetProcAddress},
  {HOOKS_END}
};


static TCHAR Hooks_DLL[MAX_PATH];

HANDLE hMS, hMU;

BOOL LikeUnhooked = FALSE;

LONG ThreadsIn = 0;

BOOL AmIDebuggee = FALSE;

BOOL bIsNT = FALSE;

#ifdef SAFE_DEBUGGEE
RCINFO TimeoutRCI;

typedef LONG (WINAPI *TNSIT)(HANDLE, DWORD, LPVOID, DWORD);
TNSIT NSIT;

DWORD WINAPI HookDebuggee(LPVOID lpRCI) {
  InterlockedIncrement(&ThreadsIn);
  DWORD AHResult = ErrorAHSuccess;
  DWORD PFl;
  PRCINFO pRCI = (PRCINFO)lpRCI;
  do {
    Sleep(1);
    PFl = hGetProcFlags(pRCI->hProcess);
  } while( (!(PFl & (RC_PF_NOOPEN | RC_PF_16TERM))) &&
           (PFl & RC_PF_NOTINITED) );

  if(!(PFl & (RC_PF_NOOPEN | RC_PF_16TERM))) {
    if(NSIT)
      NSIT(pRCI->hThread, 17, NULL, 0);
    SetThreadPriority(pRCI->hThread, THREAD_PRIORITY_HIGHEST);
    ResumeThread(pRCI->hThread);

    // Wait fo result if needed
    // WaitForSingleObject(pRCI->hThread, INFINITE);
    // GetExitCodeThread(pRCI->hThread, &AHResult);
    // if(pRCI->ProcFlags & RC_PF_NATIVE)
    //   pRCI->RtlFreeMem(pRCI->hProcess, pRCI->ThreadStack);
    // if(pRCI->RCFlags & RC_FL_OWNFREE)
    //   pRCI->RtlFreeMem(pRCI->hProcess, pRCI->ThreadBody);
    // ... report result ...
  }
  CloseHandle(pRCI->hThread);
  CloseHandle(pRCI->hProcess);
  LocalFree(lpRCI);
  InterlockedDecrement(&ThreadsIn);
  return(AHResult);
}
#endif
   
/////////////////////////////////////////////////////////
VOID WINAPI HookProcess(HANDLE hProcess, DWORD dwProcessId, const CHAR *CmdLine, BOOL IsUnicode) {
  DWORD i, j, AHResult;
  CHAR  CmdLineA[256];
  TCHAR Msg[2048];

  if(IsUnicode) {
    sprintf(CmdLineA, "%S", CmdLine);
    CmdLine = CmdLineA;
  }
  i = _stprintf(Msg, TEXT("\n******\n0x%.3X='%s':\nHooking 0x%.3X='%hs' .."),
            GetCurrentProcessId(), GetCommandLine(),
            dwProcessId, CmdLine);
  WaitForSingleObject(hMU, INFINITE);
  WriteFile(hMS, Msg, (++i)*sizeof(TCHAR), &j, NULL);
  DWORD pfl = hGetProcFlags(hProcess);
  if(pfl & RC_PF_DEBUGGED) {
#ifdef TRY_DEBUGGEE
    // Target was created right now (is not initialized) and is debugged....
    // NT: Don't wait for result at all (dwMilliseconds = 0).
    LONG ExpTime = 0;
    PRCINFO lpRCI = NULL;

    if(bIsNT) {
#ifdef SAFE_DEBUGGEE
      if(lpRCI = (PRCINFO)LocalAlloc(LPTR, sizeof(RCINFO))) {
        memcpy(lpRCI, &TimeoutRCI, sizeof(RCINFO));
      }
#endif
    }
    else {
      // 9x: Different debuggers -> diferent results
      if(AmIDebuggee)
        // I belong to debug chain (initial process was created with "debug children" allowed:
        // There is a chance remote code can be executed.
        // Exception: MS debuggers (designed for NT mainly), suspend all threads in all debuggees
        //  -> this thread can wait until MS debugger resumes it.
        ExpTime = TRY_DEBUGGEE;
      else 
        // I am debugger:
        // Start thread, but don't wait for so long.
        ExpTime = 127;
    }

    AHResult = hEstablishApiHooks(lpRCI, Hooks_DLL, hProcess, ExpTime);

#ifdef SAFE_DEBUGGEE
    if(lpRCI && (AHResult==ErrorAHTimeOut)) {
      DWORD TID;
      if(!CloseHandle(CreateThread(NULL, 0,  HookDebuggee, lpRCI, 0, &TID))) {
        ResumeThread(lpRCI->hThread);
        CloseHandle(lpRCI->hThread);
        CloseHandle(lpRCI->hProcess);
        LocalFree(lpRCI);
      }
    }
#endif

#else
    AHResult = ErrorDebugged;
#endif
  }
  else {
    AHResult = hEstablishApiHooks(NULL, Hooks_DLL, hProcess, 40000);
  }
  i = _stprintf(Msg, TEXT("%s\n******"), EAHErrorMessages[AHResult-ErrorAHMin]);
  WriteFile(hMS, Msg, (++i)*sizeof(TCHAR), &j, NULL); 
  ReleaseMutex(hMU);
}

HMODULE hDLL;

#ifdef __TURBOC__
#pragma argsused
BOOL APIENTRY DllEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
#else
BOOL APIENTRY DllMain(HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
#endif
{ 
  DWORD i;
  if(ul_reason_for_call == DLL_PROCESS_ATTACH) {
     hDLL = hModule;
    // full Hooks_DLL name is required for interprocess loading
    GetModuleFileName(hModule, Hooks_DLL, sizeof(Hooks_DLL));
    if((hMS = CreateFile(MSName, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
      return(FALSE);
    //bypass traverse checking
    HINSTANCE hntdll;
    BYTE WasEn;
    typedef LONG (WINAPI *TRAP)(DWORD, BOOL, DWORD, BYTE*);
    TRAP RAP = NULL;
    if(hntdll = GetModuleHandle(_T("ntdll.dll")))
      if(RAP = (TRAP)GetProcAddress(hntdll, "RtlAdjustPrivilege"))
        RAP(23, TRUE, 0, &WasEn);
    if(!(hMU = OpenMutex(SYNCHRONIZE, FALSE, MUName)))
      hMU = OpenMutex(SYNCHRONIZE, FALSE, BaseMUName);
    if(!hMU) {
      CloseHandle(hMS);
      return(FALSE);
    }
    if(RAP)
      RAP(23, WasEn, 0, &WasEn);
    AmIDebuggee = hGetProcFlags(GetCurrentProcess()) & RC_PF_DEBUGGED;
    bIsNT = IsNT;
#ifdef SAFE_DEBUGGEE
    memcpy(&TimeoutRCI, GetDefaultRCInfo(), sizeof(RCINFO));
    TimeoutRCI.RCFlags = RC_FL_OWNTIMEOUT;
    if(bIsNT) {
      HINSTANCE hntdll;
      if(hntdll = GetModuleHandle(_T("ntdll.dll")))
        NSIT = (TNSIT)GetProcAddress(hntdll, "NtSetInformationThread");
    }
#endif
      
  }
  else
    if(ul_reason_for_call == DLL_PROCESS_DETACH) {
      CloseHandle(hMU);
      CloseHandle(hMS);
      if(!lpReserved)
        for(i=0; i < 1000 && ThreadsIn; i++) //no infinite cycle!
          Sleep(10);
    }
  return(TRUE);
}



BOOL WINAPI NewCreateProcessW(
    LPCWSTR lpApplicationName,
    LPWSTR lpCommandLine,
    LPSECURITY_ATTRIBUTES lpProcessAttributes,
    LPSECURITY_ATTRIBUTES lpThreadAttributes,
    BOOL bInheritHandles,
    DWORD dwCreationFlags,
    LPVOID lpEnvironment,
    LPCWSTR lpCurrentDirectory,
    LPSTARTUPINFOW lpStartupInfo,
    LPPROCESS_INFORMATION lpProcessInformation
   ) {
   InterlockedIncrement(&ThreadsIn);
   TCreateProcessW OrigCreateProcessW = ApiHookChain[1].dwFlags & HOOK_BY_NAME ? (TCreateProcessW)UCPW[0].ReturnWhat : OldCreateProcessW;
   if(!OrigCreateProcessW)
     OrigCreateProcessW = CreateProcessW;
   BOOL Result = OrigCreateProcessW(
    lpApplicationName,
    lpCommandLine,
    lpProcessAttributes,
    lpThreadAttributes,
    bInheritHandles,
    dwCreationFlags | CREATE_SUSPENDED,
    lpEnvironment,
    lpCurrentDirectory,
    lpStartupInfo,
    lpProcessInformation
   );
   if(Result && !LikeUnhooked) {
     HookProcess(lpProcessInformation->hProcess, lpProcessInformation->dwProcessId, lpCommandLine ? (LPCSTR)lpCommandLine : (LPCSTR)lpApplicationName, TRUE);
   }
   if(Result && !(dwCreationFlags & CREATE_SUSPENDED))
     ResumeThread(lpProcessInformation->hThread);
   InterlockedDecrement(&ThreadsIn);
   return(Result);
}

BOOL WINAPI NewCreateProcessA(
    LPCSTR lpApplicationName,
    LPSTR lpCommandLine,
    LPSECURITY_ATTRIBUTES lpProcessAttributes,
    LPSECURITY_ATTRIBUTES lpThreadAttributes,
    BOOL bInheritHandles,
    DWORD dwCreationFlags,
    LPVOID lpEnvironment,
    LPCSTR lpCurrentDirectory,
    LPSTARTUPINFOA lpStartupInfo,
    LPPROCESS_INFORMATION lpProcessInformation
   ) {
   InterlockedIncrement(&ThreadsIn);
   TCreateProcessA OrigCreateProcessA = ApiHookChain[2].dwFlags & HOOK_BY_NAME ? (TCreateProcessA)UCPA[0].ReturnWhat : OldCreateProcessA; 
   if(!OrigCreateProcessA)
     OrigCreateProcessA = CreateProcessA;
   BOOL Result = OrigCreateProcessA(
    lpApplicationName,
    lpCommandLine,
    lpProcessAttributes,
    lpThreadAttributes,
    bInheritHandles,
    dwCreationFlags | CREATE_SUSPENDED,
    lpEnvironment,
    lpCurrentDirectory,
    lpStartupInfo,
    lpProcessInformation
   );
   if(Result && !LikeUnhooked) {
     HookProcess(lpProcessInformation->hProcess, lpProcessInformation->dwProcessId, lpCommandLine ? lpCommandLine : lpApplicationName, FALSE);
   }
   if(Result && !(dwCreationFlags & CREATE_SUSPENDED))
     ResumeThread(lpProcessInformation->hThread);
   InterlockedDecrement(&ThreadsIn);
   return(Result);
}   

static STARTUPINFOA stinfo = {sizeof(stinfo)};

UINT WINAPI NewWinExec(
    LPCSTR lpCmdLine,
    UINT uCmdShow
   ) {
   InterlockedIncrement(&ThreadsIn);
   UINT Result;
   PROCESS_INFORMATION prinfo;
   stinfo.wShowWindow = uCmdShow;
   TCreateProcessA OrigCreateProcessA = ApiHookChain[2].dwFlags & HOOK_BY_NAME ? (TCreateProcessA)UCPA[0].ReturnWhat : OldCreateProcessA; 
   if(!OrigCreateProcessA)
     OrigCreateProcessA = CreateProcessA;
   if(!LikeUnhooked && OrigCreateProcessA(
    NULL,
    (LPSTR)lpCmdLine,
    NULL,
    NULL,
    FALSE,
    CREATE_SUSPENDED,
    NULL,
    NULL,
    &stinfo,
    &prinfo
   )) {
     HookProcess(prinfo.hProcess, prinfo.dwProcessId, lpCmdLine, FALSE);
     ResumeThread(prinfo.hThread);
     CloseHandle(prinfo.hThread);
     CloseHandle(prinfo.hProcess);
     InterlockedDecrement(&ThreadsIn);
     return(32);
     }
   else {
     TWinExec OrigWinExec = ApiHookChain[3].dwFlags & HOOK_BY_NAME ? (TWinExec)UWEX[0].ReturnWhat : OldWinExec;
     if(!OrigWinExec)
       OrigWinExec = WinExec;
     Result = OrigWinExec(lpCmdLine, uCmdShow);
     InterlockedDecrement(&ThreadsIn);
     return(Result);
   } 
}

DWORD WINAPI NewLoadModule(
    LPCSTR lpModuleName,
    LPVOID lpParameterBlock
   ) {
   InterlockedIncrement(&ThreadsIn);
   DWORD Result;
   PROCESS_INFORMATION prinfo;
   int i;
   char CString[MAX_PATH];
   TLoadModule OrigLoadModule = ApiHookChain[4].dwFlags & HOOK_BY_NAME ? (TLoadModule)ULOM[0].ReturnWhat : OldLoadModule;
   if(!OrigLoadModule)
     OrigLoadModule = LoadModule;
   if(LikeUnhooked) {
     InterlockedDecrement(&ThreadsIn);
     return(OrigLoadModule(lpModuleName, lpParameterBlock));
   }

   if(((LPLOADPARMS32)lpParameterBlock)->dwReserved != 0) {
     Result = OrigLoadModule(lpModuleName, lpParameterBlock);
     InterlockedDecrement(&ThreadsIn);
     return(Result);
   }
   if(((LPLOADPARMS32)lpParameterBlock)->lpCmdShow)
     if(((LPLOADPARMS32)lpParameterBlock)->lpCmdShow->MustBe2 != 2) {
       Result = OrigLoadModule(lpModuleName, lpParameterBlock);
       InterlockedDecrement(&ThreadsIn);
       return(Result);
     }
     else
       stinfo.wShowWindow = ((LPLOADPARMS32)lpParameterBlock)->lpCmdShow->HowToShow;
   if(((LPLOADPARMS32)lpParameterBlock)->lpCmdLine->Length != 0) {
     for(i=1; i<=((LPLOADPARMS32)lpParameterBlock)->lpCmdLine->Length; i++)
       CString[i-1] = ((LPLOADPARMS32)lpParameterBlock)->lpCmdLine->String[i];
     CString[i] = '\0';
   }
   //todo: handle Environment here

   TCreateProcessA OrigCreateProcessA = ApiHookChain[2].dwFlags & HOOK_BY_NAME ? (TCreateProcessA)UCPA[0].ReturnWhat : OldCreateProcessA; 
   if(!OrigCreateProcessA)
     OrigCreateProcessA = CreateProcessA;
   if(OrigCreateProcessA(
    lpModuleName,
    ((LPLOADPARMS32)lpParameterBlock)->lpCmdLine->Length !=0 ? CString : NULL,
    NULL,
    NULL,
    FALSE,
    CREATE_SUSPENDED,
    NULL,
    NULL,
    &stinfo,
    &prinfo
   )) {
     HookProcess(prinfo.hProcess, prinfo.dwProcessId, lpModuleName, FALSE);
     ResumeThread(prinfo.hThread);
     CloseHandle(prinfo.hThread);
     CloseHandle(prinfo.hProcess);
     InterlockedDecrement(&ThreadsIn);
     return(32);
     }
   else {
     Result = OrigLoadModule(lpModuleName, lpParameterBlock);
     InterlockedDecrement(&ThreadsIn);
     return(Result);
   }
}


FARPROC WINAPI NewGetProcAddress(HMODULE hModule, LPCSTR lpProcName) {
  FARPROC Result;
  InterlockedIncrement(&ThreadsIn);
  TGetProcAddress OrigGetProcAddress = ApiHookChain[7].dwFlags & HOOK_BY_NAME ? (TGetProcAddress)UGPA[0].ReturnWhat : OldGetProcAddress;
  if(!OrigGetProcAddress)
    OrigGetProcAddress = GetProcAddress;
  Result = OrigGetProcAddress(hModule, lpProcName);
  if(!LikeUnhooked && ((DWORD)lpProcName >= 0x10000))
    if(hModule == GetModuleHandle(TEXT("KERNEL32.DLL"))) { 
      if(!lstrcmpA(lpProcName, "CreateProcessA"))
         Result = (FARPROC)NewCreateProcessA;
      if(!lstrcmpA(lpProcName, "WinExec"))
         Result = (FARPROC)NewWinExec;
      if(!lstrcmpA(lpProcName, "LoadModule"))
         Result = (FARPROC)NewLoadModule;
      if(!lstrcmpA(lpProcName, "LoadLibraryA"))
         Result = (FARPROC)NewLoadLibraryA;
      if(!lstrcmpA(lpProcName, "LoadLibraryExA"))
         Result = (FARPROC)NewLoadLibraryExA;
      if(!lstrcmpA(lpProcName, "GetProcAddress"))
         Result = (FARPROC)NewGetProcAddress;
    }
  InterlockedDecrement(&ThreadsIn);
  return(Result);
}


#define WAS_OVERWRITE 0xFEDC0000L

VOID HookNewModule(
   LPCSTR lpLibFileName
   ){
   int i;
   ApiHookChain[0].ModuleExport = HOOKS_DYNAMIC;
   for(i=1; i<NHOOKS-1; i++)
     if(ApiHookChain[i].dwFlags & (HOOK_BY_NAME | HOOK_BY_ADDRESS))
       ApiHookChain[i].ModuleImport = lpLibFileName;
     else
       if(ApiHookChain[i].dwFlags & (HOOK_OVERWRITE | HOOK_RAW))
         ApiHookChain[i].dwFlags = WAS_OVERWRITE;  //zero overwrite/raw hooks -> avoid double hooking
   EstablishApiHooks(NULL, (LPCTSTR)ApiHookChain, GetCurrentProcessId(), 0);
}

HINSTANCE WINAPI NewLoadLibraryA(
    LPCSTR lpLibFileName
   ){
   InterlockedIncrement(&ThreadsIn);
   HANDLE hMod = GetModuleHandleA(lpLibFileName);
   TLoadLibraryA OrigLoadLibraryA = ApiHookChain[5].dwFlags & HOOK_BY_NAME ? (TLoadLibraryA)ULLA[0].ReturnWhat : OldLoadLibraryA;
   if(!OrigLoadLibraryA)
     OrigLoadLibraryA = LoadLibraryA;
   HINSTANCE Result = OrigLoadLibraryA(lpLibFileName);
   if(!LikeUnhooked && !hMod && Result)
     HookNewModule(lpLibFileName);
   InterlockedDecrement(&ThreadsIn);
   return(Result);
}

HINSTANCE WINAPI NewLoadLibraryExA(
    LPCSTR lpLibFileName,
    HANDLE hFile,
    DWORD dwFlags
   ) {
   InterlockedIncrement(&ThreadsIn);
   HANDLE hMod = GetModuleHandleA(lpLibFileName);
   TLoadLibraryExA OrigLoadLibraryExA = ApiHookChain[6].dwFlags & HOOK_BY_NAME ? (TLoadLibraryExA)ULLX[0].ReturnWhat : OldLoadLibraryExA;
   if(!OrigLoadLibraryExA)
     OrigLoadLibraryExA = LoadLibraryExA;
   HINSTANCE Result = OrigLoadLibraryExA(lpLibFileName, hFile, dwFlags);
   if(!LikeUnhooked && !hMod && Result && (dwFlags != LOAD_LIBRARY_AS_DATAFILE))
     HookNewModule(lpLibFileName);
   InterlockedDecrement(&ThreadsIn);
   return(Result);
}

#ifdef __cplusplus
extern "C"
#endif
__declspec(dllexport) DWORD HooksCanUnloadNow(VOID) {
   DWORD i;
   LikeUnhooked = TRUE;
   DWORD ErrorUnload = ErrorUnloaded;
   HANDLE ModuleExport;

//UnhookApis requires AHChain as it was before any modification
//from NewAPIs (LLA, LLExA) -> return zeroed HOOK_OVERWRITE:
   for(i=1; i<NHOOKS-1; i++)
    if(ApiHookChain[i].dwFlags == WAS_OVERWRITE)
      ApiHookChain[i].dwFlags = HOOK_OVERWRITE;

//Report unloading hazard:
//All OVERWRITE : unload possible
//Any EXPORT    : unload very risky (here for illustration : EXPORT can't appear in AHChain)
//Any _BY_      : unload risky

   for(i=0; i<NHOOKS-1; i++)
     if((ApiHookChain[i].dwFlags & HOOK_EXPORT) &&
        (ModuleExport = GetModuleHandle(ApiHookChain[i].ModuleExport))) {
       if((bIsNT) ||
          (ApiHookChain[i].dwFlags & HOOK_HARD) ||
          ((int)ModuleExport > 0)) {
         ErrorUnload = ErrorUnloadVeryRisky;
         break;
       }
     }
     else
       if(ApiHookChain[i].dwFlags & (HOOK_BY_ADDRESS | HOOK_BY_ADDRESS))
         ErrorUnload = ErrorUnloadRisky;

   if(!UnhookApis(ApiHookChain, WHOLE_AH_CHAIN))
     return(ErrorOverHooked);
   else {
     //Free heap memory
     for(i=1; i<NHOOKS-1; i++)
       if((ApiHookChain[i].dwFlags & (HOOK_OVERWRITE | HOOK_RAW))
          && *(HLOCAL*)(ApiHookChain[i].ModuleImport))
         *(HLOCAL*)(ApiHookChain[i].ModuleImport) = LocalFree(*(HLOCAL*)ApiHookChain[i].ModuleImport);
     if(ThreadsIn)
       return(ErrorThreadsIn);
     else
       if(ErrorUnload == ErrorUnloaded)
         FreeLibraryAndExitThread(hDLL, ErrorUnload);
       return(ErrorUnload);
   }
}