'Attribute VB_Name = "IncludeModule"
Public Const HOOK_EXPORT       As Long = 1
Public Const HOOK_BY_NAME      As Long = 2
Public Const HOOK_BY_ADDRESS   As Long = 4
Public Const HOOK_HARD         As Long = 8
Public Const HOOK_LOAD_IMPORT  As Long = 16
Public Const HOOK_SPECIAL      As Long = 32
Public Const HOOK_NOT_NT       As Long = 64
Public Const HOOK_NOT_9X       As Long = 128
Public Const HOOK_OVERWRITE    As Long = 256
Public Const HOOK_RAW          As Long = 512
Public Const HOOK_ALL_SAFE     As Long = 1024

Public Const HOOK_EXACT        As Long = (HOOK_EXPORT Or HOOK_BY_NAME)
Public Const HOOK_ALL          As Long = (HOOK_EXPORT Or HOOK_BY_NAME Or HOOK_BY_ADDRESS)
Public Const HOOK_SMART        As Long = (HOOK_ALL Or HOOK_SPECIAL)
  
Public Const HOOKS_END         As Long = (-1)
Public Const HOOKS_DYNAMIC     As Long = (-2)
 
Public Const ALL_MODULES       As Long = (-1)
Public Const MAIN_MODULE       As Long = 0

Public Const ErrorAHMin        As Long = &HE1C2F3B0
Public Const ErrorAHSuccess    As Long = (ErrorAHMin+0)
Public Const ErrorAHException  As Long = (ErrorAHMin+1)
Public Const ErrorAHOpen       As Long = (ErrorAHMin+2)
Public Const ErrorAHPrepare    As Long = (ErrorAHMin+3)
Public Const ErrorAHTimeOut    As Long = (ErrorAHMin+4)
Public Const ErrorAHRemote     As Long = (ErrorAHMin+5)
Public Const ErrorAHMax        As Long = (ErrorAHMin+5)

Public Const RC_FL_OWNTIMEOUT  As Long = 1
Public Const RC_FL_TERMINATE   As Long = 2
Public Const RC_FL_OWNFREE     As Long = 4
Public Const RC_FL_UNHIDE9X    As Long = 8
Public Const RC_FL_DEFSD       As Long = 16

Public Const RC_PF_DEBUGGED    As Long = 1
Public Const RC_PF_16TERM      As Long = 2
Public Const RC_PF_NOOPEN      As Long = 4
Public Const RC_PF_NATIVE      As Long = 8
Public Const RC_PF_NOTINITED   As Long = 16

Public Const RCBlockStart      As Long = &HAC

Public Const LAC_PASCAL        As Long = &H80000000
Public Const LAC_FASTCALL      As Long = &H40000000
Public Const LAC_COMCALL       As Long = &H20000000
Public Const LAC_DELPHI        As Long = &H10000000

Public Type   RCINFO
  RCFlags     As Long
  ProcFlags   As Long
  RtlAllocMem As Long
  RtlFreeMem  As Long
  hProcess    As Long
  ProcessId   As Long
  hThread     As Long
  ThreadId    As Long
  ThreadBody  As Long
  ThreadStack As Long
End Type

Public Const WHOLE_AH_CHAIN    As Long = (-1)


Public Type ADDRESS_CONTENTS
    ReturnWhere As Long
    ReturnWhat  As Long
End Type

Public Type API_UNHOOK
    MaxNoAddr   As Long
    CurNoAddr   As Long
    WhereWhat() As ADDRESS_CONTENTS
End Type


Public Declare Function EstablishApiHooks Lib "ApiHooks.dll" _
    Alias "EstablishApiHooksA" _
   (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal lProcessID As Long, _
    ByVal dwMilliseconds As Long) As Long

Public Declare Function hEstablishApiHooks Lib "ApiHooks.dll" _
    Alias "hEstablishApiHooksA" _
   (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal hProcess As Long, _
    ByVal dwMilliseconds As Long) As Long

Public Declare Function IsModuleLoaded Lib "ApiHooks.dll" _
    Alias "IsModuleLoadedA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal lProcessID As Long, _
    ByVal dwMilliseconds As Long) As Long

Public Declare Function hIsModuleLoaded Lib "ApiHooks.dll" _
    Alias "hIsModuleLoadedA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal hProcess As Long, _
    ByVal dwMilliseconds As Long) As Long

Public Declare Function UnloadModule Lib "ApiHooks.dll" _
    Alias "UnloadModuleA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal lProcessID As Long, _
    ByVal dwMilliseconds As Long, ByVal HowManyTimes As Long) _
    As Long

Public Declare Function hUnloadModule Lib "ApiHooks.dll" _
    Alias "hUnloadModuleA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal hProcess As Long, _
    ByVal dwMilliseconds As Long, ByVal HowManyTimes As Long) _
    As Long

Public Declare Function LoadAndCall Lib "ApiHooks.dll" _
    Alias "LoadAndCallA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal lProcessID As Long, _
    ByVal dwMilliseconds As Long, ByVal HowManyTimes As Long, _
    ByVal ApiNameOrOrd As Any, ByVal nArgs As Long, pArgs As Any) As Long

Public Declare Function hLoadAndCall Lib "ApiHooks.dll" _
    Alias "hLoadAndCallA" _
    (pRCINFO as RCINFO, ByVal lpszDll As String, ByVal hProcess As Long, _
    ByVal dwMilliseconds As Long, ByVal HowManyTimes As Long, _
    ByVal ApiNameOrOrd As Any, ByVal nArgs As Long, pArgs As Any) As Long

Public Declare Function RemoteExecute Lib "ApiHooks.dll" _
    Alias "RemoteExecute" _
    (pRCINFO as RCINFO, ByVal lProcessID As Long, ByVal dwMilliseconds As Long, _
    ByVal lpBlock As Long, ByVal BlockSize As Long, _
    ByVal lpParameter As Long) As Long

Public Declare Function hRemoteExecute Lib "ApiHooks.dll" _
    Alias "hRemoteExecute" _
    (pRCINFO as RCINFO, ByVal hProcess As Long, ByVal dwMilliseconds As Long, _
    ByVal lpBlock As Long, ByVal BlockSize As Long, _
    ByVal lpParameter As Long) As Long

Public Declare Function HookApi Lib "ApiHooks.dll" _
    Alias "HookApiA" ( _
    ByVal ExportModule As Any, _
    ByVal ApiNameOrOrd As Any, _
    ByVal dwFlags As Long, _
    ByVal ImportModule As Any, _
    UnhookAddresses As Any, _
    ByVal HookAddress As Long, _
    ByRef ExcludeModules As Any _
    ) As Long

Public Declare Function GetDefaultRCInfo Lib "ApiHooks.dll" _
    Alias "GetDefaultRCInfo" () As Long

Public Declare Function GetProcFlags Lib "ApiHooks.dll" _
    Alias "GetProcFlags" (ByVal ProcessId As Long) As Long

Public Declare Function hGetProcFlags Lib "ApiHooks.dll" _
    Alias "hGetProcFlags" (ByVal hProcess As Long) As Long

Public Declare Function UnhookApis Lib "ApiHooks.dll" _
    Alias "UnhookApis" ( _
    ByVal ApiHookChain As Any, _
    ByVal nApiHooks As Long _
    ) As Long
