#ifndef _MKWIN32_
#define _MKWIN32_ 1

#define MKWIN32_INSESSION (-1)
#define MKWIN32_DETERMINESESSION (-2)

#define BaseCsrName _T("csrss.exe")

#define MKWIN32_NTDLL _T("ntdll.dll")

#ifndef STATUS_UNSUCCESSFUL
#define STATUS_UNSUCCESSFUL 0xC0000001
#endif

#ifndef _PRCWORKS_
#include <PrcWorks.h>
#endif

#ifndef _APIHOOKS_
#include <ApiHooks.h>
#endif


// registers TargetPID in calling process' CSR
// a) calling process must be Win32
// b) TargetPID must not be registered in its CSR
LONG WINAPI CreateWin32Process(HANDLE hTargetProcess, HANDLE hTargetThread, DWORD TargetPID, DWORD TargetTID, DWORD SubSys) {
  typedef LONG (WINAPI *TCCCS)(LPDWORD, DWORD, DWORD, DWORD);
  typedef LONG (WINAPI *TNTQP)(HANDLE, DWORD, DWORD*, DWORD, DWORD*);
  static TCCCS CCCS = NULL;
  static TNTQP NTQP = NULL;
  HMODULE hntdll;
  if(!CCCS || !NTQP)
    if(hntdll = GetModuleHandle(MKWIN32_NTDLL)) {
      CCCS = (TCCCS)GetProcAddress(hntdll, "CsrClientCallServer");
      NTQP = (TNTQP)GetProcAddress(hntdll, "NtQueryInformationProcess");
    }

  DWORD BaseSrvCreateProcess[0xC4/sizeof(DWORD)] ={0};
  BaseSrvCreateProcess[0x20/sizeof(DWORD)] = STATUS_UNSUCCESSFUL;
  BaseSrvCreateProcess[0x28/sizeof(DWORD)] = (DWORD)hTargetProcess;
  BaseSrvCreateProcess[0x2C/sizeof(DWORD)] = (DWORD)hTargetThread;
  BaseSrvCreateProcess[0x30/sizeof(DWORD)] = TargetPID;
  BaseSrvCreateProcess[0x34/sizeof(DWORD)] = TargetTID;
  if(SubSys == 2)
    BaseSrvCreateProcess[0x28/sizeof(DWORD)] |= 2;
  if(CCCS && NTQP) {
    DWORD BasicPI[0x18/sizeof(DWORD)] = {0};
    NTQP(hTargetProcess, 0, BasicPI, 0x18, NULL);
    BaseSrvCreateProcess[0xB0/sizeof(DWORD)] = BasicPI[0x04/sizeof(DWORD)];
    CCCS(BaseSrvCreateProcess, 0, 0x00010000, (char)GetVersion()>5 ? 0x98 : 0x28);
  }
  return(BaseSrvCreateProcess[0x20/sizeof(DWORD)]);
}


// registers TargetTID in hCsrProc
LONG WINAPI Nt2Win32Thread(HANDLE hTargetThread, DWORD TargetPID, DWORD TargetTID, HANDLE hCsrProc) {
  HANDLE DuphTargetThread;
  LONG Result = STATUS_UNSUCCESSFUL;
  if(DuplicateHandle(GetCurrentProcess(), hTargetThread, hCsrProc, &DuphTargetThread, 0, FALSE, DUPLICATE_SAME_ACCESS)) {
    RCINFO rci;   
    memcpy(&rci, GetDefaultRCInfo(), sizeof(rci)); rci.RCFlags = 0;
    LPVOID rCID;
    if(rCID = rci.RtlAllocMem(hCsrProc, sizeof(TargetPID)+sizeof(TargetTID))) {
      DWORD lCID[2] = {TargetPID, TargetTID};
      if(WriteProcessMemory(hCsrProc, rCID, lCID, sizeof(lCID), NULL)) {
        LPVOID Params[2] = {DuphTargetThread, rCID};
        Result = hLoadAndCall(&rci, _T("csrsrv.dll"), hCsrProc, 60000, 0, _T("CsrCreateRemoteThread"), 2, Params);
        hLoadAndCall(&rci, MKWIN32_NTDLL, hCsrProc, 60000, 0, _T("NtClose"), 1, &DuphTargetThread);
      }
      rci.RtlFreeMem(hCsrProc, rCID);
    }
  }
  return(Result);
}


// registers TargetTID in TargetPID's CSR
// a) TargetPID must be Win32
// requires granted debug privilege 
LONG WINAPI CreateWin32Thread(LONG Session, HANDLE hTargetThread, DWORD TargetPID, DWORD TargetTID) {

  LONG Result = STATUS_UNSUCCESSFUL, i, CsrPID = 0;

  TCHAR FullCsrName[127];
  ExpandEnvironmentStrings(_T("\\??\\%SystemRoot%\\SYSTEM32\\")BaseCsrName, FullCsrName, 127);

  TCHAR SesFullCsrName[127];
  if(Session == MKWIN32_INSESSION)
    _stprintf(SesFullCsrName, _T("%s"), FullCsrName);
  else {
    if(Session == MKWIN32_DETERMINESESSION)
      Session = GetSessionId(TargetPID);
    _stprintf(SesFullCsrName, _T("%02u/%s"), Session, FullCsrName);
  }
  CsrPID = ProcessName2PID(SesFullCsrName);
  HANDLE hCsr;
  if(hCsr = OpenProcess(PROCESS_DUP_HANDLE | PROCESS_QUERY_INFORMATION |
                        PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE |
                        PROCESS_CREATE_THREAD | READ_CONTROL,
                        FALSE, CsrPID)) {
       Result = Nt2Win32Thread(hTargetThread, TargetPID, TargetTID, hCsr);
       CloseHandle(hCsr); 
  }
  return(Result);
}

#undef BaseCsrName
#undef MKWIN32_NTDLL

#endif
